module Model {
    interface OnMineSweeperEventListener {
        onCreate(board: MineSweeper): void;
        onOpen(cell: Cell): void;
        onDead(cell: Cell): void;
        onClear(duration: number): void;
    }
    class Cell {
        private board;
        public x: number;
        public y: number;
        public bomb: bool;
        private open;
        constructor (board: MineSweeper, x: number, y: number, bomb: bool);
        public neighbors : number;
        public opened : bool;
    }
    class MineSweeper {
        private listener;
        public width: number;
        public height: number;
        public threshold: number;
        private board;
        private start;
        constructor (listener: OnMineSweeperEventListener, width?: number, height?: number, threshold?: number);
        public getCell(x: number, y: number): Cell;
        public getNeighbors(x: number, y: number): Cell[];
        public open(x: number, y: number, root?: bool): void;
        public isBomb(x: number, y: number): bool;
        public cleared : bool;
        public getNeighborsBomb(x: number, y: number): number;
        public cells : Cell[];
    }
}
