var View;
(function (View) {
    var m = Model;
    var Render = (function () {
        function Render() { }
        Render.prototype.run = function ($parent) {
            this.$parent = $parent;
            $parent.empty();
            this.game = new m.MineSweeper(this);
        };
        Render.prototype.onCreate = function (board) {
            for(var w = 0; w < board.width; w++) {
                for(var h = 0; h < board.height; h++) {
                    var $el = this.createCellElement(w, h);
                    if(h == 0) {
                        $el.addClass("head");
                    }
                    $el.addClass("cell");
                    this.$parent.append($el);
                }
            }
        };
        Render.prototype.onOpen = function (cell) {
            var $el = $("#cell-" + cell.x + "-" + cell.y);
            $el.addClass("opened").addClass("neighbor" + cell.neighbors);
        };
        Render.prototype.onDead = function (cell) {
            var $el = $("#cell-" + cell.x + "-" + cell.y);
            $el.addClass("bomb");
        };
        Render.prototype.onClear = function (duration) {
            var message = "" + this.game.width + "x" + this.game.height + ",地雷率" + this.game.threshold + "のマインスイーパを" + (duration / 1000) + "秒でクリアしました！";
            createTweetButton(message);
            alert("クリアしました！ツイートボタンを押してみましょう。");
        };
        Render.prototype.createCellElement = function (x, y) {
            var _this = this;
            var $el = $("<span>");
            $el.click(function (e) {
                return _this.game.open(x, y);
            });
            $el.attr("id", "cell-" + x + "-" + y);
            return $el;
        };
        return Render;
    })();
    View.Render = Render;    
})(View || (View = {}));
//@ sourceMappingURL=view.js.map
